select
    an.numero as numero,
    cbasica.nome as categoria_perda,
    (case when (cbasica.cdcategoria = 7) then
            (case cprodutiva.cdcategoria when 3 then 'Seca' when 4 then 'Lactao' else null end)
       else null end) as categoria_produtiva_perda,
    se.nome as setor_perda,
    cob.data as data_cobertura,
    (case when (cob.cdtiporeproducao = 1) then 'Inseminacao' when (cob.cdtiporeproducao = 2) then
        'Cobertura' when (cob.cdtiporeproducao = 3) then 'Transferncia' else null end) as tipo_cobertura,
    tou.numero as touro,
    paiemb.numero as pai_embriao,
    maeemb.numero as mae_embriao,
    rep.data as data_diagnostico,
    next.data as data_perda_gestacao,
    (case when (next.cdtiporeproducao = 1) then 'Inseminao' when (next.cdtiporeproducao = 2) then
        'Cobertura' when (next.cdtiporeproducao = 3) then 'Transferncia' when (next.diagnostico = 'N')
        then 'Diagnstico' when (next.cio in (1,2)) then 'Cio' when (next.cdtiporeproducao = 7) then
        'Aborto' else null end) as tipo_perda
from
    reproducao rep
    join reproducao next on next.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = rep.cdanimal and
            ((re.cdtiporeproducao in (1,2,3)) or (re.diagnostico = 'N') or (re.cio in (1,2)) or
            (re.cdtiporeproducao = 7 and re.cdtipoparto = 3)) and re.data > rep.data order by re.data)
    join animal an on an.cdanimal = rep.cdanimal
    join reproducao cob on cob.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = rep.cdanimal and
            re.cdtiporeproducao in (1,2,3) and re.data < rep.data order by re.data desc)
    left join animal tou on tou.cdanimal = cob.cdreprodutor
    left join animal emb on emb.cdanimal = cob.cdembriao
    left join animal paiemb on paiemb.cdanimal = emb.cdpai
    left join animal maeemb on maeemb.cdanimal = emb.cdmae
    left join setor se on se.cdsetor =
        (select setor from sp_setoranimal(next.cdanimal, next.data))
    join categoria cbasica on cbasica.cdcategoria =
        (select cbasica from sp_categoriaanimal(next.data, 'CDANIMAL = ' || next.cdanimal))
    left join categoria cprodutiva on cprodutiva.cdcategoria =
        (select cprodutiva from sp_categoriaanimal(next.data, 'CDANIMAL = ' || next.cdanimal))
where
    rep.diagnostico = 'P'
    and not exists (select * from reproducao re where re.cdanimal = rep.cdanimal and ((re.diagnostico = 'P') or
                    (re.cdtiporeproducao = 7 and re.cdtipoparto <> 3)) and re.data > rep.data and re.data < next.data)
    and cob.data between 
---INFORMAR O INCIO DO PERODO NO FORMATO AAAA-MM-DD
'2014-01-01' 
and 
---INFORMAR O FINAL DO PERODO NO FORMATO AAAA-MM-DD
'2014-12-31'
order by
    next.data
